OpenTTD Source: NWidgetSpacer Class Reference

OpenTTD Source 12.2

Public Member Functions
NWidgetSpacer Class Reference
Hierarchical widgets

Spacer widget. More...

`#include <widget_type.h>`

Inheritance diagram for NWidgetSpacer:

## Public Member Functions
| NWidgetSpacer (int width, int height)
| Generic spacer widget. More...
void | SetupSmallestSize (Window *w, bool init_array) override
void | FillNestedArray (NWidgetBase **array, uint length) override
void | Draw (const Window *w) override
void | SetDirty (const Window *w) const override
| Mark the widget as 'dirty' (in need of repaint). More...
NWidgetCore * | GetWidgetFromPos (int x, int y) override
Public Member Functions inherited from NWidgetResizeBase
| NWidgetResizeBase (WidgetType tp, uint fill_x, uint fill_y)
| Constructor for resizable nested widgets. More...
void | AdjustPaddingForZoom () override
void | SetMinimalSize (uint min_x, uint min_y)
| Set minimal size of the widget. More...
void | SetMinimalSizeAbsolute (uint min_x, uint min_y)
| Set absolute (post-scaling) minimal size of the widget. More...
void | SetMinimalTextLines (uint8 min_lines, uint8 spacing, FontSize size)
| Set minimal text lines for the widget. More...
void | SetFill (uint fill_x, uint fill_y)
| Set the filling of the widget from initial size. More...
void | SetResize (uint resize_x, uint resize_y)
| Set resize step of the widget. More...
void | AssignSizePosition (SizingType sizing, uint x, uint y, uint given_width, uint given_height, bool rtl) override
Public Member Functions inherited from NWidgetBase
| NWidgetBase (WidgetType tp)
| Base class constructor. More...
virtual NWidgetBase * | GetWidgetOfType (WidgetType tp)
| Retrieve a widget by its type. More...
virtual bool | IsHighlighted () const
virtual TextColour | GetHighlightColour () const
virtual void | SetHighlighted (TextColour highlight_colour)
void | SetPadding (uint8 top, uint8 right, uint8 bottom, uint8 left)
| Set additional space (padding) around the widget. More...
uint | GetHorizontalStepSize (SizingType sizing) const
| Get the horizontal sizing step. More...
uint | GetVerticalStepSize (SizingType sizing) const
| Get the vertical sizing step. More...
Rect | GetCurrentRect () const
Public Member Functions inherited from ZeroedMemoryAllocator
void * | operator new (size_t size)
| Memory allocator for a single class instance. More...
void * | operator new[] (size_t size)
| Memory allocator for an array of class instances. More...
void | operator delete (void *ptr)
| Memory release for a single class instance. More...
void | operator delete[] (void *ptr)
| Memory release for an array of class instances. More...

## Additional Inherited Members
Data Fields inherited from NWidgetResizeBase
uint | min_x
| Minimal horizontal size of only this widget.
uint | min_y
| Minimal vertical size of only this widget.
bool | absolute
| Set if minimum size is fixed and should not be resized.
uint | uz_min_x
| Unscaled Minimal horizontal size of only this widget.
uint | uz_min_y
| Unscaled Minimal vertical size of only this widget.
uint8 | uz_text_lines
| 'Unscaled' text lines, stored for resize calculation.
uint8 | uz_text_spacing
| 'Unscaled' text padding, stored for resize calculation.
FontSize | uz_text_size
| 'Unscaled' font size, stored for resize calculation.
Data Fields inherited from NWidgetBase
WidgetType | type
| Type of the widget / nested widget.
uint | fill_x
| Horizontal fill stepsize (from initial size, `0` means not resizable).
uint | fill_y
| Vertical fill stepsize (from initial size, `0` means not resizable).
uint | resize_x
| Horizontal resize step (`0` means not resizable).
uint | resize_y
| Vertical resize step (`0` means not resizable).
uint | smallest_x
| Smallest horizontal size of the widget in a filled window.
uint | smallest_y
| Smallest vertical size of the widget in a filled window.
uint | current_x
| Current horizontal size (after resizing).
uint | current_y
| Current vertical size (after resizing).
int | pos_x
| Horizontal position of top-left corner of the widget in the window.
int | pos_y
| Vertical position of top-left corner of the widget in the window.
NWidgetBase * | next
| Pointer to next widget in container. Managed by parent container widget.
NWidgetBase * | prev
| Pointer to previous widget in container. Managed by parent container widget.
uint8 | padding_top
| Paddings added to the top of the widget. Managed by parent container widget.
uint8 | padding_right
| Paddings added to the right of the widget. Managed by parent container widget. (parent container may swap this with padding_left for RTL)
uint8 | padding_bottom
| Paddings added to the bottom of the widget. Managed by parent container widget.
uint8 | padding_left
| Paddings added to the left of the widget. Managed by parent container widget. (parent container may swap this with padding_right for RTL)
uint8 | uz_padding_top
| Unscaled top padding, for resize calculation.
uint8 | uz_padding_right
| Unscaled right padding, for resize calculation.
uint8 | uz_padding_bottom
| Unscaled bottom padding, for resize calculation.
uint8 | uz_padding_left
| Unscaled left padding, for resize calculation.
Protected Member Functions inherited from NWidgetBase
void | StoreSizePosition (SizingType sizing, uint x, uint y, uint given_width, uint given_height)
| Store size and position. More...

## Detailed Description

Spacer widget.

Definition at line 568 of file widget_type.h.

## Constructor & Destructor Documentation

## ◆ NWidgetSpacer()

NWidgetSpacer::NWidgetSpacer | ( | int | width,
|  | int | height
| ) |  |

Generic spacer widget.

Parameters

  width | Horizontal size of the spacer widget.
  height | Vertical size of the spacer widget.

Definition at line 1561 of file widget.cpp.

References NWidgetResizeBase::SetMinimalSize(), and NWidgetResizeBase::SetResize().

## Member Function Documentation

## ◆ Draw()

void NWidgetSpacer::Draw | ( | const Window * | w | ) |
| overridevirtual

Draw the widgets of the tree. The function calls Window::DrawWidget for each widget with a non-negative index, after the widget itself is painted.

Parameters

  w | Window that owns the tree.

Implements NWidgetBase.

Definition at line 1577 of file widget.cpp.

## ◆ FillNestedArray()

void NWidgetSpacer::FillNestedArray | ( | NWidgetBase ** | array,
|  | uint | length
| ) |  |
| overridevirtual

Fill the Window::nested_array array with pointers to nested widgets in the tree.

Parameters

  array | Base pointer of the array.
  length | Length of the array.

Implements NWidgetBase.

Definition at line 1573 of file widget.cpp.

## ◆ GetWidgetFromPos()

NWidgetCore * NWidgetSpacer::GetWidgetFromPos | ( | int | x,
|  | int | y
| ) |  |
| overridevirtual

Retrieve a widget by its position.

Parameters

  x | Horizontal position relative to the left edge of the window.
  y | Vertical position relative to the top edge of the window.

Returns
  Returns the deepest nested widget that covers the given position, or `nullptr` if no widget can be found.

Implements NWidgetBase.

Definition at line 1587 of file widget.cpp.

## ◆ SetDirty()

void NWidgetSpacer::SetDirty | ( | const Window * | w | ) | const
| overridevirtual

Mark the widget as 'dirty' (in need of repaint).

Parameters

  w | Window owning the widget.

Reimplemented from NWidgetBase.

Definition at line 1582 of file widget.cpp.

## ◆ SetupSmallestSize()

void NWidgetSpacer::SetupSmallestSize | ( | Window * | w,
|  | bool | init_array
| ) |  |
| overridevirtual

Compute smallest size needed by the widget.

The smallest size of a widget is the smallest size that a widget needs to display itself properly. In addition, filling and resizing of the widget are computed. The function calls Window::UpdateWidgetSize for each leaf widget and background widget without child with a non-negative index.

Parameters

  w | Window owning the widget.
  init_array | Initialize the `w->nested_array`.

Note
  After the computation, the results can be queried by accessing the smallest_x and smallest_y data members of the widget.

Implements NWidgetBase.

Definition at line 1567 of file widget.cpp.

References NWidgetResizeBase::min_x, NWidgetResizeBase::min_y, NWidgetBase::smallest_x, and NWidgetBase::smallest_y.

The documentation for this class was generated from the following files:

- src/widget_type.h
- src/widget.cpp